/*
** authored by rue
** modified for ImgLikeOpera by Danil Ivanov
*/

/* Pre-Install Cleanup (for prior versions) */

// temp-dir
initInstall("pre-install", "/tempDir", "0.0"); // dummy-install - allows committance of file-operations
var tempDir = getFolder(getFolder("Profile", "chrome"), "imglikeopera-temp"); // imglikeopera temp-dir
if (!File.exists(tempDir)) dirCreate(tempDir); // create temp-dir if it doesn't exist
performInstall(); // commit dir-creation changes

// file-check array
var dirArray = new Array();
dirArray[0] = new Array();
  dirArray[0].push(getFolder("Profile", "chrome"));   // profile-chrome
  dirArray[0].push("imglikeopera");                   // filename - profile jar
  dirArray[0].push(".jar");                           // filename - extension
dirArray[1] = new Array();
  dirArray[1].push(getFolder("chrome"));              // app-chrome
  dirArray[1].push("imglikeopera");                   // filename - root jar
  dirArray[1].push(".jar");                           // filename - extension
dirArray[2] = new Array();
  dirArray[2].push(getFolder("components"));          // app-components
  dirArray[2].push("nsImgLikeOpera");                 // filename - root component
  dirArray[2].push(".js");                            // filename - extension
dirArray[3] = new Array();
  dirArray[3].push(getFolder("Profile"));             // profile
  dirArray[3].push("XUL FastLoad File");              // filename - xul cache mac
  dirArray[3].push("");                               // filename - extension
dirArray[4] = new Array();
  dirArray[4].push(getFolder("Profile"));             // profile
  dirArray[4].push("XUL");                            // filename - xul cache macosX
  dirArray[4].push(".mfast");                         // filename - extension
dirArray[5] = new Array();
  dirArray[5].push(getFolder("Profile"));             // profile
  dirArray[5].push("XUL");                            // filename - xul cache linux
  dirArray[5].push(".mfasl");                         // filename - extension
dirArray[6] = new Array();
  dirArray[6].push(getFolder("Profile"));             // profile
  dirArray[6].push("XUL");                            // filename - xul cache windows
  dirArray[6].push(".mfl");                           // filename - extension

// file-check loop
for (var i = 0 ; i < dirArray.length ; i++) {
  initInstall("pre-install", "/rename", "0."+i); // reopen dummy-install
  var currentDir = dirArray[i][0];
  var nameMain = dirArray[i][1];
  var nameEnd = dirArray[i][2];
  var tempDir = getFolder(getFolder("Profile", "chrome"), "imglikeopera-temp"); // imglikeopera temp-dir
  if (!File.exists(tempDir)) dirCreate(tempDir); // create temp-dir if it doesn't exist
  var previousFile = getFolder(currentDir, nameMain + nameEnd); // previous jar
  var newNameMain = "imglikeopera-uninstalled";// nameMain + "-uninstalled";
  var newName = newNameMain; // + nameEnd;
  var n = 1;
  
  if (File.exists(previousFile)) {
    if (File.exists(getFolder(currentDir, newName))) // <-- change 'currentDir' to 'tempDir' to revert: old-style
      while(File.exists(getFolder(currentDir, newName))) { // <-- ditto.
        newName = new String(newNameMain + n); // + nameEnd); // find a unique-name for our "move-to" destination
        n++;
      }
    // rename file
    File.rename(previousFile, newName); // rename the previous jar to the unique-name
    performInstall(); // commit file-rename changes
    
    // -- this can be (un)commented without worry.. it just seemingly fails to move, every time
    // move file
    initInstall("pre-install", "/move", "0."+i); // reopen dummy-install
    previousFile = getFolder(currentDir, newName); // get prev. version by its new name
    File.move(previousFile, tempDir); // move jar to temp-dir
    performInstall(); // commit file-move changes
    
    // delete original
    initInstall("pre-install", "/delete", "0."+i); // reopen dummy-install
    if (File.exists(previousFile)) File.remove(previousFile); // delete original (in case it didn't completely move)
    performInstall(); // commit file-deletion changes
  }
}


// Main Install Routine

// only load after the Pre-Install Cleanup completes
if (true) {
  // install constants
  const APP_DISPLAY_NAME = "ImgLikeOpera";
  const APP_NAME = "imglikeopera";
  const APP_PACKAGE = "/imglikeopera.imfo.ru";
  const APP_VERSION = "0.6.15";
  
  const APP_JAR_FILE = "imglikeopera.jar";
  const APP_JAR_LOC = 'chrome/' + APP_JAR_FILE;
  
  const APP_COMP_FILE = "components/nsImgLikeOpera.js";
  const APP_COMP_LOC = APP_COMP_FILE;
  const APP_COMP_XPT = "components/nsIImgLikeOpera.xpt";
  
  const APP_CONTENT_FOLDER = "content/";
  const APP_LOCALES = ["de-DE", "en-US", "es-ES", "it-IT", "ja-JP", "pl-PL", "ru-RU"];
  
  const INST_TO_PROFILE = "Install "+APP_DISPLAY_NAME+" in your profile?\n(..you wont have to reinstall when updating the browser).\n\nClick Cancel to install "+APP_DISPLAY_NAME+" in the browser root.";
  const ROOT_FAILED___TRY_INST_TO_PROFILE = "You didn't have permission to install as root.\n Would you like to force profile-installation?";
  
  const profileChrome = getFolder("Profile", "chrome");
  const previousJarInProfile = getFolder(profileChrome, "imglikeopera.jar");
  const previousJarInRoot = getFolder("chrome", "imglikeopera.jar");
}

// initialize our install
initInstall(APP_NAME, APP_PACKAGE, APP_VERSION);

if (buildID < 2005091400) {
  if (buildID == 0) {
    if (!confirm("Install script can't find Mozilla build date. Use it at your own risk...\r\nContinue installation?"))
      cancelInstall(-23);
  } else {
    alert("Sorry: ImgLikeOpera only works in Mozilla builds after 2005-09-14.");
    cancelInstall(-23);
  }
}

if (File.exists(previousJarInProfile) || File.exists(previousJarInRoot)) {
  // check for previous install
  var installedHere = File.exists(previousJarInProfile)?"profile ":"";
  installedHere += (File.exists(previousJarInProfile) && File.exists(previousJarInRoot))?"*and* ":"";
  installedHere += File.exists(previousJarInRoot)?"root ":"";
  installedHere += (File.exists(previousJarInProfile) && File.exists(previousJarInRoot))?"directories":"directory";
  
  alert("Sorry: ImgLikeOpera is already installed in your " + installedHere + ".");
  cancelInstall(-23); // we can't overwrite, so don't install further

} else {
  
  // runtime component registration only works since 2003-06-24..
  var instToProfile = false;
  instToProfile = confirm(INST_TO_PROFILE);
  
  // install component
  var compf = getFolder("components");
  var errComponent = addFile(APP_PACKAGE, APP_VERSION, APP_COMP_LOC, compf, null);
  var errComponent = addFile(APP_PACKAGE, APP_VERSION, APP_COMP_XPT, compf, null);
  addFile(APP_NAME, "components/.autoreg", getFolder("Program"), "");
  
  // install jar-file
  var chromef = instToProfile ? getFolder("Profile", "chrome") : getFolder("chrome");
  var errJar = addFile(APP_PACKAGE, APP_VERSION, APP_JAR_LOC, chromef, null);
  
  // install default prefs
  const prefDirs = [ getFolder(getFolder('Profile'),'pref') , getFolder(getFolder(getFolder('Program'),'defaults'),'pref') ];
  
  for(var j=prefDirs.length-1; j>=0; j--) {
    var prefDir = prefDirs[j];
    
    if(!File.exists(prefDir))
      File.dirCreate(prefDir);
    
    var errPref = addFile(null, 'defaults/preferences/' + APP_NAME + '.js', prefDir, null);
      
    if (errPref != SUCCESS)
      alert("Default preferences failed to install.");
  }
  
  // if root-install was attempted and failed, ask the user what to do
  if (!instToProfile && (errComponent != SUCCESS || errJar != SUCCESS)) {
    instToProfile = confirm(ROOT_FAILED___TRY_INST_TO_PROFILE);
    if (instToProfile) {
      chromef = getFolder("Profile", "chrome");
      errJar = addFile(APP_PACKAGE, APP_VERSION, APP_JAR_LOC, chromef, null);
    }
    else errJar = "root install failed";
  }
  
  // if we've successfully installed the files, register them
  if (errJar == SUCCESS) {
    var jar = getFolder(chromef, APP_JAR_FILE);
    var i;
    const chromeFlag=instToProfile?PROFILE_CHROME:DELAYED_CHROME;
    
    registerChrome(CONTENT | chromeFlag, jar, APP_CONTENT_FOLDER);
    registerChrome(SKIN    | chromeFlag, jar, "skin/");
    
    for (i=APP_LOCALES.length-1;i>=0;i--)
      registerChrome(LOCALE | chromeFlag, jar, "locale/"+APP_LOCALES[i]+"/");
    
    var err = performInstall();
    if (err == SUCCESS || err == 999) {
      alert(APP_DISPLAY_NAME + " " + APP_VERSION + " is now installed.\n"
            +"Just restart to activate.");
    } else {
      alert("Install failed. Error code:" + err);
      cancelInstall(err);
    }
  } else {
    alert("Failed to create " +APP_JAR_FILE +"\n"
         +"You probably don't have appropriate permissions \n"
         +"(write access to your profile or chrome directory). \n"
         +"_____________________________\nError code:" + errJar);
    cancelInstall(errJar);
  }
}
